"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ReactUpdates = require("react/lib/ReactUpdates");

var _ReactUpdates2 = _interopRequireDefault(_ReactUpdates);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SOURCE_NONE = -1;
var SOURCE_FUNCTION = 0;
var SOURCE_PROMISE = 1;

var BatchingStrategy = function () {
  function BatchingStrategy() {
    _classCallCheck(this, BatchingStrategy);

    this.source = SOURCE_NONE;
    this.promise = null;
  }

  _createClass(BatchingStrategy, [{
    key: "batchedUpdates",
    value: function batchedUpdates(callback, a, b, c, d, e) {
      var _this = this;

      if (a) {
        // standard call - events, components etc
        var isBatchingUpdates = this.isBatchingUpdates;
        if (!isBatchingUpdates) {
          this.source = SOURCE_FUNCTION;
        }
        this.run(callback, a, b, c, d, e);
        if (!isBatchingUpdates && this.source === SOURCE_FUNCTION) {
          this.close();
        }
        return;
      }
      if (this.isBatchingUpdates) {
        if (callback instanceof Function) {
          if (this.source === SOURCE_FUNCTION) {
            this.run(callback, a, b, c, d, e);
          } else if (this.source === SOURCE_PROMISE) {
            (function () {
              var promise = _this.promise.then(function () {
                return _this.run(callback, a, b, c, d, e);
              }).then(function () {
                return _this.closePromise(promise);
              });
              _this.promise = promise;
            })();
          }
        } else if (callback instanceof Promise) {
          (function () {
            if (_this.source === SOURCE_FUNCTION) {
              _this.source = SOURCE_PROMISE;
              _this.promise = Promise.resolve();
            }
            var promise = _this.promise.then(function () {
              return callback;
            }).catch(function () {
              return null;
            }).then(function () {
              return _this.closePromise(promise);
            });
            _this.promise = promise;
          })();
        }
      } else {
        if (callback instanceof Function) {
          this.source = SOURCE_FUNCTION;
          this.run(callback, a, b, c, d, e);
          if (this.source === SOURCE_FUNCTION) {
            this.close();
          }
        } else if (callback instanceof Promise) {
          (function () {
            _this.source = SOURCE_PROMISE;
            var promise = callback.catch(function () {
              return null;
            }).then(function () {
              return _this.closePromise(promise);
            });
            _this.promise = promise;
          })();
        }
      }
    }
  }, {
    key: "run",
    value: function run(callback, a, b, c, d, e) {
      try {
        callback(a, b, c, d, e);
      } catch (_) {
        // ignore
      }
    }
  }, {
    key: "closePromise",
    value: function closePromise(promise) {
      if (promise === this.promise) {
        this.promise = null;
        this.close();
      }
    }
  }, {
    key: "close",
    value: function close() {
      try {
        _ReactUpdates2.default.flushBatchedUpdates();
      } catch (_) {
        // ignore
      }
      this.source = SOURCE_NONE;
    }
  }, {
    key: "isBatchingUpdates",
    get: function get() {
      return this._source !== SOURCE_NONE;
    }
  }, {
    key: "source",
    get: function get() {
      return this._source;
    },
    set: function set(source) {
      this._source = source;
    }
  }, {
    key: "promise",
    get: function get() {
      return this._promise;
    },
    set: function set(promise) {
      this._promise = promise;
    }
  }]);

  return BatchingStrategy;
}();

exports.default = BatchingStrategy;